function make_node(t::AbstractTask)
    error("Cannot make a node from this task type")
end

function make_node(t::AbstractDataTask)
    return DataTaskNode(t)
end

function make_node(t::AbstractComputeTask)
    return ComputeTaskNode(t)
end

function make_edge(n1::Node, n2::Node)
    error("Can only create edges from compute to data node or reverse")
end

function make_edge(n1::ComputeTaskNode, n2::DataTaskNode)
    return Edge((n1, n2))
end

function make_edge(n1::DataTaskNode, n2::ComputeTaskNode)
    return Edge((n1, n2))
end

function show(io::IO, n::Node)
    print(io, "Node(", n.task, ")")
end

function show(io::IO, e::Edge)
    print(io, "Edge(", e.edge[1], ", ", e.edge[2], ")")
end

function ==(e1::Edge, e2::Edge)
    return e1.edge[1] == e2.edge[1] && e1.edge[2] == e2.edge[2]
end
